<?php

/**
 * SPDX-License-Identifier: EUPL-1.2
 * Authors: see /README.md
 */

namespace Seacms\ComposerInstaller;

use Composer\Composer;
use Composer\EventDispatcher\EventSubscriberInterface;
use Composer\IO\IOInterface;
use Composer\Plugin\Capable;
use Composer\Plugin\PluginInterface;
use TopFloor\ComposerCleanupVcsDirs\Plugin as TopFloorPlugin;

if (class_exists(TopFloorPlugin::class,true)){
    abstract class ParentPlugin extends TopFloorPlugin implements Capable, EventSubscriberInterface
    {
        /**
         * const to test if TopFloorPlugin
         * @var bool
         */
        protected const IS_TOP_FLOOR_PLUGIN = true;
    }
} else {
    abstract class ParentPlugin implements PluginInterface, Capable, EventSubscriberInterface
    {
        
        /**
         * const to test if TopFloorPlugin
         * @var bool
         */
        protected const IS_TOP_FLOOR_PLUGIN = false;
        
        /**
         * Deactivation hook.
         *
         * @param Composer $composer
         * @param IOInterface $io
         */
        public function deactivate(Composer $composer, IOInterface $io) {
        }

        /**
         * Uninstall hook.
         *
         * @param Composer $composer
         * @param IOInterface $io
         */
        public function uninstall(Composer $composer, IOInterface $io) {
        }
    }
}